Summary: GTK2 frontend for mencoder
Name: gmencoder
Version: 0.0.7
Release: 1
Copyright: GPL
Group: Applications/Multimedia
Source: http://gmencoder.sourceforge.net/%{name}-%{version}.tgz
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%description
GTK2 frontend for mencoder

%prep
%setup
%configure --prefix=%{_prefix}

%post

%postun

%build
make
 
%install
rm -rf %{buildroot}
%makeinstall

# Last, add system menu entries!
cat > %{name}.desktop << EOF
[Desktop Entry]
Name=GMencoder
Comment=GTK2 frontend for mencoder
Exec=gmencoder %f
Icon=gmencoder/media-play.png
Terminal=false
Type=Application
EOF

mkdir -p %{buildroot}%{_datadir}/applications
desktop-file-install --vendor contrib --delete-original \
  --dir %{buildroot}%{_datadir}/applications                      \
  --add-category X-Red-Hat-Extra                                  \
  --add-category Application                                      \
  --add-category AudioVideo                                       \
  %{name}.desktop

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc README ChangeLog INSTALL AUTHORS COPYING
%{_prefix}/*
