#include <bonobo.h>
#include <gnome.h>

#include "gmencoder.h"

int CalculaBitrateA ()
{
	if (!strcmp ("lame", (char *) gtk_entry_get_text (GTK_ENTRY(strPrincipal.entCmbCodecAudio))))
	{
		return gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(strPrincipal.spBitrateLame));

	}
	else if (!strcmp ("copy", (char *) gtk_entry_get_text (GTK_ENTRY(strPrincipal.entCmbCodecAudio))))
	{
		return BitrateOrigenA();
	}
}

int GeneraOptsAudioLame (char *CodecAudio, char *OptsAudio)
{
	sprintf (CodecAudio, "-oac mp3lame");

	/* Opciones de Lame para */
	sprintf (OptsAudio, "-lameopts br=%d:q=%d:aq=%d:cbr:mode=1", 
			gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(strPrincipal.spBitrateLame)),
			gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(strPrincipal.spCalidadLame)),
			gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(strPrincipal.spCalidadAlgoritmoLame)));

	return 0;
}

int GeneraOptsAudioCopy (char *CodecAudio, char *OptsAudio)
{
	sprintf (CodecAudio, "-oac copy");

	/* Opciones de Lame para */
	sprintf (OptsAudio, " ");

	return 0;
}

int GeneraOptsAudioPcm (char *CodecAudio, char *OptsAudio)
{
	sprintf (CodecAudio, "-oac pcm");

	/* Opciones de Lame para */
	sprintf (OptsAudio, " ");

	return 0;
}

int GeneraOptsAudio (char *CodecAudio, char *OptsAudio)
{
	if (!strcmp ("lame", (char *) gtk_entry_get_text (GTK_ENTRY(strPrincipal.entCmbCodecAudio))))
	{
		return GeneraOptsAudioLame (CodecAudio, OptsAudio);
	}
	else if (!strcmp ("pcm", (char *) gtk_entry_get_text (GTK_ENTRY(strPrincipal.entCmbCodecAudio))))
	{
		return GeneraOptsAudioPcm (CodecAudio, OptsAudio);
	}
	else if (!strcmp ("copy", (char *) gtk_entry_get_text (GTK_ENTRY(strPrincipal.entCmbCodecAudio))))
	{
		return GeneraOptsAudioCopy (CodecAudio, OptsAudio);
	}

	return -1;
}
